1000 REM Prsentationsgraphikprogramm in BASIC
1010 REM
1020 REM IBM-PC Version erstellt am 12.8.88 von Manfred Winterhoff
1030 REM
1040 REM Die Bedeutung der in diesem Programm verwendeten Variablen
1050 REM
1060 REM A% = 1, wenn Tabelle verndert worden ist
1070 REM B$(I%) = Bezeichnung der Tabellenzeile I%
1080 REM C% = 1 wenn Eintrag im aktuellen Feld bearbeitet wird, 0 sonst
1090 REM D$ = Dateiname
1100 REM E$ = eingegebenes Kommandozeichen
1110 REM F = Skalierungsfaktor bei Rundung der Ober- und Untergrenze
1120 REM     und Winkel des Tortenausschnitts
1125 REM F%(1..3) = Farben fr Balken 1..3
1130 REM G = grsster Wert in der Tabelle
1140 REM H% = Hhe eines Zeichens in Graphikzeilen
1150 REM I% = 0..21 = Zhlvariable fr Schleifen ber die Zeilen der Tabelle
1160 REM              und Schleifenvariable beim Zeichnen der Achsen
1170 REM J% = 0..3 = Zhlvariable fr Schleifen ber die Spalten der Tabelle
1180 REM K = kleinster Wert in der Tabelle
1190 REM L% = 20 oder 60 = Feldlnge des aktuellen Feldes
1200 REM M% = Anzahl der verwendeten Spalten (wird vor dem Zeichnen ermittelt)
1210 REM N% = Anzahl der verwendeten Zeilen (wird vor dem Zeichnen ermittelt)
1220 REM O% = Graphikzeile der Nulllinie
1230 REM P% = Schleifenvariable bei breiteren Linien
1240 REM Q% = Tastennummer bei Lschen der Funktionstasten
1250 REM S% = 0..3 = Spaltennummer des aktuellen Feldes
1260 REM SK% = Anzahl der Stellen des grssten Tabellenwertes
1270 REM SG% = Anzahl der Stellen des kleinsten Tabellenwertes
1280 REM T$ = Zeichenkette im aktuellen Feld
1290 REM U$ = berschrift des Diagramms
1300 REM V% = Breite eines Zeichens in Graphikpunkten
1310 REM W(I%,J%) = Wert in der Tabellenzeile I%, Spalte J%
1320 REM X$ = Bezeichnung der X-Achse
1330 REM X1% = linker Rand vom aktuellen Balken & X-Position Linienpunkt
1340 REM X2% = rechter Rand vom aktuellen Balken & X-Pos. letzter Linienpunkt
1350 REM Y$ = Bezeichnung der Y-Achse
1360 REM Y = Y-Achsen Wert bei Beschriftung der Y-Achse
1370 REM Y1% = oberer Rand vom aktuellen Balken & Y-Position Linienpunkt
1380 REM Y2% = Y-Position letzter Linienpunkt
1390 REM Z% = 0..21 = Zeilennummer des aktuellen Feldes
1400 REM
1410 REM *** Dimensionieren der verwendeten Feldvariablen
1420 DIM B$(20),L$(3),W(20,3),F%(3)
1430 REM *** Definieren der Stellenanzahl-Funktion
1440 DEF FNL(X)=10^INT(LOG(ABS(X)+1E-38)/LOG(10))
1450 REM *** Lschen der Funktionstastenbelegung
1460 KEY OFF
1470 FOR Q% = 1 TO 10
1480   KEY Q%,""
1490 NEXT Q%
1500 REM Zur Sicherheit auf 80 Zeichen Textbildschirm umschalten
1510 SCREEN 0 : WIDTH 80
1515 LET F%(1) = 4 : LET F%(2) = 2 : LET F%(3) = 14
1520 LET A% = 0 ' Tabelle ist noch nicht verndert worden
1530 REM *** Standardwerte in Tabelle einsetzen
1540 IF A% THEN GOSUB 5390 ' vernderte Tabelle vergessen ?
1550 LET U$= "berschrift"
1560 LET X$ = "X-Achse"
1570 LET Y$ = "Y-Achse"
1580 FOR I% = 1 TO 20
1590   LET B$(I%) = "Name"+STR$(I%)
1600   FOR J% = 1 TO 3
1610     LET L$(J%) = "Reihe "+CHR$(ASC("@")+J%)
1620     LET W(I%,J%) = 0
1630   NEXT J%
1640 NEXT I%
1650 LET A% = 0 ' Tabelle ist noch nicht verndert worden
1660 REM *** Grundposition einstellen
1670 LET Z% = 0
1680 LET S% = 0
1690 REM *** Aufbau der Tabelle
1700 COLOR 7,0 ' Normale Schrift
1710 CLS ' Bildschirm lschen
1720 COLOR 0,7 ' Inverse Schrift
1730 PRINT "Prsentationsgraphikprogramm in BASIC                       Version vom 12.08.88"
1740 COLOR 7,0 ' Normale Schrift
1750 PRINT Y$;TAB(21);U$
1760 PRINT X$;TAB(21);L$(1);TAB(41);L$(2);TAB(61);L$(3)
1770 FOR I% = 1 TO 20
1780   PRINT B$(I%);
1790   FOR J% = 1 TO 3
1800     LET T$ = STR$(W(I%,J%))
1810     IF LEFT$(T$,1)=" " THEN LET T$ = MID$(T$,2)
1820     PRINT TAB(J%*20+1);T$;
1830   NEXT J%
1840   PRINT
1850 NEXT I%
1860 COLOR 0,7 ' Inverse Schrift
1870 PRINT "F1=Balken F2=Linie F3=Flche  F5=Sich F6=Lade F7=Inh F8=Lsch F9=Hilf F10=Ende";
1880 REM *** Eingrenzen der Position des aktuellen Tabellenfeldes
1890 IF Z%=0 AND S%>1 THEN LET S%=1
1900 REM *** Bestimmen der Feldlnge des aktuellen Tabellenfeldes
1910 IF Z%=0 AND S%>0 THEN LET L% = 60 ELSE LET L% = 20
1920 REM *** Zuweisen des Inhalts des aktuellen Tabellenfeldes an T$
1930 IF Z%=0 AND S%=0 THEN LET T$ = Y$
1940 IF Z%=0 AND S%>0 THEN LET T$ = U$
1950 IF Z%=1 AND S%=0 THEN LET T$ = X$
1960 IF Z%=1 AND S%>0 THEN LET T$ = L$(S%)
1970 IF Z%>1 AND S%=0 THEN LET T$ = B$(Z%-1)
1980 IF Z%<2 OR S%=0 THEN GOTO 2010
1990   LET T$ = STR$(W(Z%-1,S%))
2000   IF LEFT$(T$,1)=" " THEN LET T$ = MID$(T$,2)
2010 LET C% = 0 ' Feld wurde neu betreten, also noch nicht bearbeitet
2020 REM *** Ausgeben der Zeichenkette T$ in Feld Z%,S%, Lnge L%
2030 COLOR 0,7 ' inverse Schrift
2040 LOCATE Z%+2,S%*20+1
2050 PRINT T$;SPACE$(L%-LEN(T$));
2060 REM *** Cursor hinter Eintrag im aktuellen Feld stellen
2070 LOCATE Z%+2,S%*20+1+LEN(T$)
2080 REM *** Tastendruck abwarten und akzeptieren
2090 LET E$ = INKEY$
2100 IF E$="" THEN GOTO 2090 ' Noch keine Taste gedrckt
2110 IF E$>=" " THEN GOTO 2150 ' Normales Zeichen
2120 IF ASC(E$)=8 AND T$<>"" THEN GOTO 2220 ' Backspace (Zeichen lschen)
2130 IF ASC(E$)=27 AND T$<>"" THEN GOTO 2270 ' Escape (Feld lschen)
2140 GOTO 2310
2150 REM *** Normales Zeichen
2160 IF C%=0 THEN LET T$ = "" ' Eintrag im noch nicht bearbeiteten Feld lschen
2170 IF LEN(T$)>=L%-1 THEN GOTO 2090 ' hat Eintrag schon maximale Lnge ?
2180 LET T$ = T$+E$ ' neues Zeichen anhngen
2190 LET C% = 1 ' Feld wurde bearbeitet
2200 LET A% = 1 ' Tabelle wurde verndert
2210 GOTO 2020
2220 REM *** Backspace (Zeichen lschen)
2230 LET T$ = LEFT$(T$,LEN(T$)-1) ' letztes Zeichen entfernen
2240 LET C% = 1 ' Feld wurde bearbeitet
2250 LET A% = 1 ' Tabelle wurde verndert
2260 GOTO 2020
2270 REM *** Escape (Feld lschen)
2280 LET T$ = "" ' Eintrag komplett lschen
2290 LET A% = 1 ' Tabelle wurde verndert
2300 GOTO 2020
2310 REM *** mgl. vernderte Zeichenkette T$ an Tabelle zuweisen
2320 IF Z%=0 AND S%=0 THEN LET Y$ = T$
2330 IF Z%=0 AND S%>0 THEN LET U$ = T$
2340 IF Z%=1 AND S%=0 THEN LET X$ = T$
2350 IF Z%=1 AND S%>0 THEN LET L$(S%) = T$
2360 IF Z%>1 AND S%=0 THEN LET B$(Z%-1) = T$
2370 IF Z%<2 OR S%=0 THEN GOTO 2410
2380   LET W(Z%-1,S%) = VAL(T$)
2390   LET T$ = STR$(W(Z%-1,S%))
2400   IF LEFT$(T$,1)=" " THEN LET T$ = MID$(T$,2)
2410 REM *** Ausgeben der Zeichenkette T$ in Feld Z%,S%, Lnge L%
2420 COLOR 7,0 ' normale Schrift
2430 LOCATE Z%+2,S%*20+1
2440 PRINT T$;SPACE$(L%-LEN(T$));
2450 REM *** Cursortasten bearbeiten
2460 IF ASC(E$)=13 THEN GOTO 2660 ' Return (Wagenrcklauftaste)
2470 REM *** erweiterte Tastencodes bearbeiten
2480 IF LEN(E$)<2 THEN GOTO 2630
2490 LET E$ = MID$(E$,2)
2500 IF ASC(E$)=72 THEN GOTO 2750 ' Zeile hoch
2510 IF ASC(E$)=80 THEN GOTO 2780 ' Zeile runter
2520 IF ASC(E$)=75 THEN GOTO 2810 ' Spalte rechts
2530 IF ASC(E$)=77 THEN GOTO 2840 ' Spalte links
2540 IF ASC(E$)=71 THEN GOTO 2870 ' HOME Grundposition
2550 IF ASC(E$)=59 THEN GOTO 2910 ' F1 Balkendiagramm
2560 IF ASC(E$)=60 THEN GOTO 2910 ' F2 Liniendiagramm
2565 IF ASC(E$)=61 THEN GOTO 2910 ' F3 Flchendiagramm
2570 IF ASC(E$)=63 THEN GOTO 4030 ' F5 Tabelle sichern
2580 IF ASC(E$)=64 THEN GOTO 4450 ' F6 Tabelle laden
2590 IF ASC(E$)=65 THEN GOTO 4780 ' F7 Inhaltsverzeichnis anzeigen
2600 IF ASC(E$)=66 THEN GOTO 1530 ' F8 Tabelle lschen
2610 IF ASC(E$)=67 THEN GOTO 4900 ' F9 Hilfe
2620 IF ASC(E$)=68 THEN GOTO 5190 ' F10 Programmende
2630 REM *** Falsche Taste, Warnton ausgeben
2640 PRINT CHR$(7);
2650 GOTO 2020
2660 REM *** Return (Wagenrcklauftaste)
2670 LET Z% = Z%+1
2680 IF Z%<=21 THEN GOTO 1880
2690 LET Z% = 1
2700 LET S% = S%+1
2710 IF S%<=3 THEN GOTO 1880
2720 LET S% = 0
2730 LET Z% = 0
2740 GOTO 1880
2750 REM *** Zeile hoch
2760 LET Z% = (Z%+21) MOD 22
2770 GOTO 1880
2780 REM *** Zeile runter
2790 LET Z% = (Z%+1) MOD 22
2800 GOTO 1880
2810 REM *** Spalte rechts
2820 LET S% = (S%+3) MOD 4
2830 GOTO 1880
2840 REM *** Spalte links
2850 LET S% = (S%+1) MOD 4
2860 GOTO 1880
2870 REM *** Grundposition
2880 LET S% = 0
2890 LET Z% = 0
2900 GOTO 1880
2910 REM *** Balken- Linien und Flchendiagramm
2920 REM Ermittle die Anzahl der verwendeten Spalten der Tabelle
2930 LET M% = 3
2940   FOR I% = 1 TO 20
2950     IF W(I%,M%)<>0 THEN GOTO 2990
2960   NEXT I%
2970   LET M% = M%-1
2980 IF M%>0 THEN GOTO 2940
2990 REM Ermittle die Anzahl der verwendeten Zeilen der Tabelle
3000 LET N% = 20
3010   FOR J% = 1 TO M%
3020     IF W(N%,J%)<>0 THEN GOTO 3060
3030   NEXT J%
3040   LET N% = N%-1
3050 IF N%>0 THEN GOTO 3010
3060 REM Bestimme den kleinsten und den grssten Tabellenwert
3061 IF ASC(E$)=61 THEN GOTO 3142
3070   LET K = W(1,1)
3080   LET G = W(1,1)
3090   FOR I% = 1 TO N%
3100     FOR J% = 1 TO M%
3110       IF K>W(I%,J%) THEN LET K = W(I%,J%)
3120       IF G<W(I%,J%) THEN LET G = W(I%,J%)
3130     NEXT J%
3140   NEXT I%
3141 GOTO 3159
3142   REM bei Flchendiagrammen die Summe aller Spalten
3143   LET G = W(1,1)
3144   FOR J% = 2 TO M%
3145     LET G = G + W(1,J%)
3146   NEXT J%
3148   FOR I% = 2 TO N%
3149     LET F = W(I%,1)
3150     FOR J% = 2 TO M%
3151       LET F = F + W(I%,J%)
3152     NEXT J%
3154     IF F>G THEN LET G = F
3155   NEXT I%
3156   LET K = 0
3159 IF K=G THEN GOTO 1880 ' Alle Tabellenwerte gleich (z.B. Tabelle leer)
3160 REM Anpassen der Bereichsgrenzen
3170 LET F = FNL(K)
3180 IF F<FNL(G) THEN LET F = FNL(G)
3190 LET K = INT(K/F)*F
3200 LET G = INT(G/F+1)*F
3210 IF K>0 AND G>0 AND (G-K)*10>G THEN LET K = 0
3220 IF K<0 AND G<0 AND (K-G)*10<K THEN LET G = 0
3230 GOSUB 5580 ' Umschalten auf Graphikbildschirm
3240 REM Graphik beschriften
3250 PRINT Y$;TAB(17+(64-LEN(U$))/2);U$; ' Y-Achsenname und berschrift
3260 FOR Y = G TO K+(K-G)/20 STEP (K-G)/10 ' Y-Achsen-Werte
3270   PRINT
3280   PRINT TAB(15-LEN(STR$(Y)));Y
3290 NEXT Y
3300 PRINT X$;":"; ' X-Achsenname
3310 FOR I% = 1 TO N% ' X-Achsen-Bezeichnungen
3320   PRINT TAB(16+(I%-1)*(64/N%)+1);LEFT$(B$(I%),64/N%-1);
3330 NEXT I%
3340 REM Achsen zeichnen
3350 LINE (15.5*V%,H%)-(15.5*V%,22*H%)
3360 FOR I% = 1.5*H% TO 22.5*H% STEP 2*H%
3370   LINE (15*V%+1,I%)-(15.5*V%,I%)
3380   IF ASC(E$)=59 THEN GOTO 3420 ' horizontale Linien nicht bei Balken
3390     FOR J% = 16*V% TO 79*V% STEP V%
3400       LINE (J%,I%)-(J%+V%/2,I%)
3410     NEXT J%
3420 NEXT I%
3430 REM Position der Nullline ermitteln
3440 LET O% = 21.5*H%
3450 IF K<0 AND 0<G THEN LET O% = 21.5*H%+K/(G-K)*20*H%
3460 IF G<=0 THEN LET O% = 1.5*H%
3470 REM Nullline einzeichnen
3480 LINE (15.5*V%,O%)-(80*V%,O%)
3490 IF ASC(E$)<>59 THEN GOTO 3640
3500   REM Balken zeichnen
3510   FOR I% = 1 TO N%
3520     FOR J% = 1 TO M%
3525       COLOR F%(J%)
3530       LET X1% = 16*V%+64*V%/N%*(I%-1)+(64-N%)*V%/N%/M%*(J%-1)
3540       LET Y1% = 21.5*H%-(W(I%,J%)-K)/(G-K)*20*H%
3550       LET X2% = X1%+(64-N%)*V%/N%/M%
3560       IF J%=2 THEN LINE (X1%,Y1%)-(X2%,O%),F%(J%),BF
3570       IF J%<3 THEN GOTO 3610
3580       FOR X% = X1% TO X2% STEP 2
3590         LINE (X%,Y1%)-(X%,O%)
3600       NEXT X%
3610       LINE (X1%,Y1%)-(X2%,O%),F%(J%),B
3620     NEXT J%
3630   NEXT I%
3640 IF ASC(E$)<>60 THEN GOTO 3881
3650   REM Linien zeichnen
3660   FOR J% = 1 TO M%
3665     COLOR F%(J%)
3670     LET X1% = 16*V%+64*V%/N%*.5
3680     LET Y1% = 21.5*H%-(W(1,J%)-K)/(G-K)*20*H%
3690     IF J%=2 THEN LINE (X1%-4,Y1%-3)-(X1%+4,Y1%+3),F%(J%),BF
3700     IF J%<3 THEN GOTO 3740
3710       LINE (X1%-2,Y1%-2)-(X1%-2,Y1%+2)
3720       LINE (X1%,Y1%-2)-(X1%,Y1%+2)
3730       LINE (X1%+2,Y1%-2)-(X1%+2,Y1%+2)
3740     LINE (X1%-4,Y1%+3)-(X1%+4,Y1%-3),F%(J%),B
3750     FOR I% = 2 TO N%
3760       LET X2% = 16*V%+64*V%/N%*(I%-.5)
3770       LET Y2% = 21.5*H%-(W(I%,J%)-K)/(G-K)*20*H%
3780       LINE (X1%,Y1%)-(X2%,Y2%)
3790       LET X1% = X2%
3800       LET Y1% = Y2%
3810       IF J%=2 THEN LINE (X1%-4,Y1%-3)-(X1%+4,Y1%+3),1,BF
3820       IF J%<3 THEN GOTO 3860
3830         LINE (X1%-2,Y1%-2)-(X1%-2,Y1%+2)
3840         LINE (X1%,Y1%-2)-(X1%,Y1%+2)
3850         LINE (X1%+2,Y1%-2)-(X1%+2,Y1%+2)
3860       LINE (X1%-4,Y1%+3)-(X1%+4,Y1%-3),F%(J%),B
3870     NEXT I%
3880   NEXT J%
3881 IF ASC(E$)<>61 THEN GOTO 3899
3882   FOR J% = M% TO 1 STEP -1
	 COLOR F%(J%)
3883     LET X1% = 16*V%+64*V%/N%*.5
3884     LET A = W(1,1)
3885     FOR X% = 2 TO J%
3886       LET A = A + W(1,X%)
3887     NEXT X%
3888     LET Y1% = 21.5*H%-(A-K)/(G-K)*20*H%
3889     FOR I% = 2 TO N%
3890       LET X2% = 16*V%+64*V%/N%*(I%-.5)
3891       LET A = W(I%,1)
3892       FOR X% = 2 TO J%
3893         LET A = A + W(I%,X%)
3894       NEXT X%
3895       LET Y2% = 21.5*H%-(A-K)/(G-K)*20*H%
	   FOR X% = X1% TO X2%
	     LET Y = Y1%+(X%-X1%)*(Y2%-Y1%)/(X2%-X1%)
	     IF J%=3 OR J%=2 AND (X% AND 1)=1 THEN LINE (X%,Y)-(X%,O%-1)
	     IF J%=1 OR J%=2 AND (X% AND 1)=1 THEN LINE (X%,Y)-(X%,O%-1),0
	   NEXT X%
	   LINE (X1%,Y1%)-(X2%,Y2%)
	   LET X1% = X2%
	   LET Y1% = Y2%
3897     NEXT I%
3898   NEXT J%
3899 REM Legende
3900 LET I% = 1
3910 FOR J% = 1 TO M%
3915   COLOR F%(J%)
3920   PRINT TAB(I%+2);L$(J%);
3930   IF J%=2 THEN LINE ((I%-1)*V%,23*H%)-(I%*V%,24*H%),F%(J%),BF
3940   IF J%<3 THEN GOTO 3980
3950   FOR X% = (I%-1)*V% TO I%*V% STEP 2
3960     LINE (X%,23*H%)-(X%,24*H%)
3970   NEXT X%
3980   LINE ((I%-1)*V%,23*H%)-(I%*V%,24*H%),F%(J%),B
3990   LET I% = I%+LEN(L$(J%))+4
4000 NEXT J%
4010 GOSUB 5670 ' Tastendruck abwarten bei Graphikbildschirm
4020 GOTO 1690
4030 REM *** Tabelle sichern
4040 COLOR 0,7
4050 LOCATE 1,1
4060 PRINT "Sichere Tabelle in Datei:";SPACE$(55);
4070 LOCATE 1,27
4080 GOSUB 5490
4090 IF D$=".TAB" THEN GOTO 4400
4100 REM Erst testen, ob Datei schon vorhanden
4110 ON ERROR GOTO 4230
4120 OPEN D$ FOR INPUT AS #1
4130 ON ERROR GOTO 0
4140 CLOSE #1
4150 LOCATE 1,1
4160 PRINT "Die Datei ";D$;" existiert schon. berschreiben ? ";
4170   LET E$ = INKEY$
4180   IF E$="" THEN GOTO 4170
4190   IF E$="j" OR E$="J" THEN GOTO 4240
4200   IF E$="n" OR E$="N" THEN GOTO 4400
4210   PRINT CHR$(7);
4220 GOTO 4170
4230 RESUME 4240
4240 ON ERROR GOTO 4420
4250 OPEN D$ FOR OUTPUT AS #1
4260 PRINT#1,U$
4270 PRINT#1,X$
4280 PRINT#1,Y$
4290 FOR J% = 1 TO 3
4300   PRINT#1,L$(J%)
4310 NEXT J%
4320 FOR I% = 1 TO 20
4330   PRINT#1,B$(I%)
4340   FOR J% = 1 TO 3
4350     PRINT#1,W(I%,J%)
4360   NEXT J%
4370 NEXT I%
4380 CLOSE #1
4390 LET A% = 0 ' Tabelle gilt nicht mehr als verndert
4400 ON ERROR GOTO 0
4410 GOTO 1690
4420 LOCATE 1,1
4430 PRINT "Die Datei ";D$;" kann nicht beschrieben werden."
4440 RESUME 5170
4450 REM *** Tabelle laden
4460 IF A% THEN GOSUB 5390 ' vernderte Tabelle vergessen ?
4470 COLOR 0,7
4480 LOCATE 1,1
4490 PRINT "Lade Tabelle von Datei:";SPACE$(57);
4500 LOCATE 1,25
4510 GOSUB 5490
4520 IF D$=".TAB" THEN GOTO 4710
4530 ON ERROR GOTO 4720
4540 OPEN D$ FOR INPUT AS #1
4550 ON ERROR GOTO 4750
4560 LINE INPUT#1,U$
4570 LINE INPUT#1,X$
4580 LINE INPUT#1,Y$
4590 FOR J% = 1 TO 3
4600   LINE INPUT#1,L$(J%)
4610 NEXT J%
4620 FOR I% = 1 TO 20
4630   LINE INPUT#1,B$(I%)
4640   FOR J% = 1 TO 3
4650     INPUT#1,W(I%,J%)
4660   NEXT J%
4670 NEXT I%
4680 ON ERROR GOTO 0
4690 CLOSE #1
4700 LET A% = 0 ' Tabelle wurde noch nicht verndert
4710 GOTO 1690
4720 LOCATE 1,1
4730 PRINT "Die Datei ";D$;" existiert nicht."
4740 GOSUB 5720
4741 RESUME 1520
4750 LOCATE 1,1
4760 PRINT "Die Datei ";D$;" kann nicht gelesen werden."
4770 RESUME 5170
4780 REM *** Inhaltsverzeichnis anzeigen
4790 CLS
4800 COLOR 0,7
4810 PRINT "Die Namen der im aktuellen Inhaltsverzeichnis abgespeicherten Tabellen ...      ";
4820 COLOR 7,0
4830 ON ERROR GOTO 4870
4840 FILES "*.TAB"
4850 GOTO 5170
4860 RESUME 4870
4870 PRINT "keine"
4880 GOSUB 5720 ' Tastendruck abwarten bei Textbildschirm
4890 GOTO 1690
4900 REM *** Hilfe
4910 CLS
4920 COLOR 0,7
4930 PRINT "Hilfe zum Programm Darstellung von Linien- und Balkendiagrammen in BASIC        ";
4940 COLOR 7,0
4950 PRINT "Dieses Programm erzeugt Linien- und Balkendiagramme aus Zahlentabellen, die"
4960 PRINT "der Benutzer des Programms zuvor erstellen muss."
4970 PRINT "Auf dem Bildschirm ist zu Programmbeginn eine mit Hilfswerten ausgefllte"
4980 PRINT "Tabelle zu sehen. Der Benutzer des Programms muss diese Hilfswerte durch seine"
4990 PRINT "eigenen ersetzen. Eingetippte Zeichen ersetzen den Eintrag im aktuellen Feld."
5000 PRINT "Das aktuelle Feld ist invers dargestellt. Die Cursortasten bewegen das aktuelle"
5010 PRINT "Feld. Die Taste [Backspace] lscht das letzte Zeichen im Eintrag des aktuellen"
5020 PRINT "Feldes, die Taste [Esc] lscht den gesamten Eintrag, die Wagenrcklauftaste"
5030 PRINT "[Enter] wechselt ins nchste Feld."
5040 PRINT "Wenn die Tabelle komplett ausgefllt worden ist, bewirkt ein Druck auf eine der"
5050 PRINT "Funktionstasten die automatische Erstellung eines Diagramms."
5060 PRINT "F1 erzeugt ein Balkendiagramm"
5070 PRINT "F2 erzeugt ein Liniendiagramm"
5080 PRINT "F3 erzeugt ein Flchendiagramm"
5090 PRINT "F4"
5100 PRINT "Die Tabelle kann abgespeichert und zur Wiederverwendung geladen werden."
5110 PRINT "F5 speichert die Tabelle in einer Datei."
5120 PRINT "F6 ld eine Tabelle von einer Datei."
5130 PRINT "F7 zeigt die Namen der im aktuellen Inhaltsverzeichnis abgelegten Tabellen."
5140 PRINT "F8"
5150 PRINT "F9 zeigt diesen Hilfsbidschirm an."
5160 PRINT "F10 dient zum Verlassen des Programms und zur Rckkehr zu BASIC."
5170 GOSUB 5720 ' Tastendruck abwarten bei Textbildschirm
5180 GOTO 1690
5190 REM *** Programmende
5200 IF A% THEN GOSUB 5390 ' vernderte Tabelle vergessen ?
5210 COLOR 7,0 ' normale Schrift
5220 CLS ' Bildschirm lschen
5230 REM Funktionstasten wieder auf Standardwerte setzen
5240 KEY 1,"LIST "
5250 KEY 2,"RUN"+CHR$(13)
5260 KEY 3,"LOAD"+CHR$(34)
5270 KEY 4,"SAVE"+CHR$(34)
5280 KEY 5,"CONT"+CHR$(13)
5290 KEY 6,","+CHR$(34)+"LPT1:"+CHR$(34)+CHR$(13)
5300 KEY 7,"TRON"+CHR$(13)
5310 KEY 8,"TROFF"+CHR$(13)
5320 KEY 9,"KEY "
5330 KEY 10,"SCREEN 0,0,0"+CHR$(13)
5340 REM Loslassen der Taste F10 abwarten
5350 IF INKEY$<>"" THEN GOTO 5350
5360 REM Funktionstastenzeile wieder einschalten
5370 KEY ON
5380 END
5390 REM === Unterprogramm: vernderte Tabelle vergessen ?
5400 COLOR 0,7 ' inverse Schrift
5410 LOCATE 1,1
5420 PRINT "Vernderte Tabelle vergessen ?";SPACE$(50);
5430 LOCATE 1,32
5440 LET E$ = INKEY$ ' Tastendruck abwarten
5450 IF E$="N" OR E$="n" THEN GOTO 1690 ' Kommando abbrechen
5460 IF E$="J" OR E$="j" THEN RETURN ' Kommando weiterfhren
5470 IF E$<>"" THEN PRINT CHR$(7); ' Falsche Taste gedrckt
5480 GOTO 5440
5490 REM === Unterprogramm: Dateinamen entgegennehmen
5500 LINE INPUT D$
5510 FOR I% = 1 TO LEN(D$)
5520   LET E$ = MID$(D$,I%,1)
5530   IF E$<"a" OR E$>"z" THEN GOTO 5550
5540     LET D$ = LEFT$(D$,I%-1)+CHR$(ASC(E$)-32)+MID$(D$,I%+1)
5550 NEXT I%
5560 IF INSTR(D$,".")=0 THEN LET D$ = D$+".TAB"
5570 RETURN
5580 REM === Unterprogramm: Umschalten auf Graphikbildschirm
5581 REM Fr EGA gilt: SCREEN 7 = 320 x 200, 8 x 8 Matrix
5582 REM               SCREEN 8 = 640 x 200, 8 x 8 Matrix
5583 REM               SCREEN 9 = 640 x 350, 8 x 14 Matrix, andere Farben
5584 ON ERROR GOTO 5589
5585 SCREEN 8
5586 LET H% = 8
5587 LET V% = 8
5588 RETURN
5589 RESUME 5590
5590 DEF SEG = 64 : IF PEEK(73)>6 THEN GOTO 5630
5600 LET H% = 8
5610 LET V% = 8
5620 GOTO 5650
5630 LET H% = 14
5640 LET V% = 9
5650 SCREEN 2
5660 RETURN
5670 REM === Unterprogramm: Tastendruck abwarten im Graphikmode
5675 COLOR 7,0
5680 PRINT TAB(54);"Druecke beliebige Taste ...";
5690 IF INKEY$="" THEN GOTO 5690
5700 SCREEN 0 : WIDTH 80
5710 RETURN
5720 REM === Unterprogramm: Tastendruck abwarten im Textmode
5730 LOCATE 24,1
5740 COLOR 0,7
5750 PRINT "Drcke eine beliebige Taste fr die Rckkehr ins Programm...                    ";
5760 COLOR 7,0
5770 IF INKEY$="" THEN GOTO 5770
5780 RETURN
