1000 PRINT "Universelles Karteikastenkastenprogramm in BASIC"
1010 PRINT
1020 PRINT "IBM PC Version vom 15.10.1988 von Manfred Winterhoff"
1030 PRINT
1040 REM Dieses Programm zeigt die Realisation eines universellen
1050 REM Karteikastens in der Programmiersprache BASIC. Bei der
1060 REM Erzeugung eines neuen, leeren Karteikastens wird festge-
1070 REM legt, welche Felder eine einzelne Karteikarte tragen
1080 REM soll. Die Bezeichnungen dieser Felder werden am Anfang
1090 REM der zur Unterbringung des Karteikarten verwendeten Datei
1100 REM abgespeichert.
1110 REM
1120 REM Bedeutung der in diesem Programm verwendeten Variablen
1130 REM
1140 REM A% = Anzahl der verwendeten Karteikarten der Kartei
1150 REM F% = Anzahl der Felder auf jeder einzelnen Karteikarte
1160 REM I% = 1..F% = Nummer des gerade bearbeiteten Feldes
1170 REM J% = Buchstabenposition bei Umwandlung in Grobuchstaben
1180 REM K% = 1..A% = Nummer der gerade bearbeiteten Karteikarte
1190 REM L% = Lnge der lngsten Feldbezeichnung der Kartei
1200 REM M% = Anzahl der zur Maske passenden Karteikarten
1210 REM N$ = Dateiname des aktuellen Karteikastens
1220 REM S$(1)..S$(F%) = Feldbezeichnungen der Kartei
1230 REM S$(F%+1)..S$(F%+F%) = Inhalt der ersten Karteikarte
1240 REM S$(A%*F%+1)..S$(A%*F%+F%) = Inhalt der A%. Karteikarte
1250 REM T% = 1..M% = Nummer der gerade gefundenen Karteikarte
1260 REM U% = 1..M% = Nummer der zu suchenden Karteikarte
1270 REM X$ = Neuer Feldeintrag beim ndern einer Karteikarte
1280 REM Z$ = die eingegebene Kennziffer bei der Menauswahl
1290 REM
1300 REM Dimensionierung der indizierten Variablen
1310 DIM S$(200)
1320 PRINT "Dieses Programm verwaltet Karteiksten auf ";
1330 PRINT "dem Computer. Bei der Erzeugung"
1340 PRINT "eines neuen, leeren Karteikastens gibt der ";
1350 PRINT "Benutzer an, welche Felder auf den"
1360 PRINT "einzelnen Karteikarten vorhanden sein sollen ";
1370 PRINT "(z.B. Name, Strae und Ort bei"
1380 PRINT "einer Adrekartei). Bei der Benutzung des ";
1390 PRINT "Karteikastens knnen neue Karteikarten"
1400 PRINT "ausgefllt, vorhandene angezeigt, verndert, ";
1410 PRINT "gelscht oder ausgedruckt werden,"
1420 PRINT "wobei der Benutzer angibt, welche Karteikarten ";
1430 PRINT "dabei verwendet werden sollen"
1440 PRINT "(z.B. nur die ausdrucken, mit dem Namen ";
1450 PRINT "Mller, nur die lschen, mit dem Ort"
1460 PRINT "Braunschweig und der Strae Bohlweg, nur ";
1470 PRINT "die ndern, mit der Postleizahl 1234)."
1480 PRINT
1490 REM Anzeige der Erffungsmens
1500 ON ERROR GOTO 0 ' Bei auftretendem Fehler normal reagieren
1510 PRINT "Auswahl:"
1520 PRINT
1530 PRINT "1) Erzeugen eines neuen Karteikastens"
1540 PRINT "2) Bearbeiten eines vorhandenen Karteikastens"
1550 PRINT "3) Anzeigen der Namen der vorhandenen Karteiksten"
1560 PRINT "4) Lschen eines vorhandenen Karteikastens"
1570 PRINT "0) Programm beenden"
1580 PRINT
1590 PRINT "Bitte Kennziffer eingeben -> ";
1600 REM Abfrage der Menauswahl
1610   LET Z$ = INKEY$
1620   IF Z$="" THEN GOTO 1610
1630   IF Z$>="0" AND Z$<="4" THEN GOTO 1670
1640   IF Z$=CHR$(3) THEN END ' Abbruch durch ^C ermglichen
1650   PRINT CHR$(7); ' Eingabefehler mit Piepston beantworten
1660   GOTO 1610
1670 PRINT Z$
1680 PRINT
1690 REM Je nach Auswahl zum geeigneten Programmstck verzweigen
1700 IF Z$="1" THEN GOTO 2010
1710 IF Z$="2" THEN GOTO 2670
1720 IF Z$="3" THEN GOTO 1750
1730 IF Z$="4" THEN GOTO 1850
1740 END
1750 REM Anzeigen der Namen der vorhandenen Karteiksten
1760 ON ERROR GOTO 1800
1770 FILES "*.KAR"
1780 PRINT
1790 GOTO 1490
1800 REM Warnmeldung, wenn keine Karteiksten existieren
1810 PRINT
1820 PRINT "Auf der Diskette sind keine Karteien abgespeichert."
1830 PRINT
1840 RESUME 1490
1850 REM Lschen eines vorhandenen Karteikastens
1860 PRINT "Der Name des zu lschenden Karteikastens ? ";
1870 GOSUB 5460
1880 PRINT
1890 IF N$="" THEN GOTO 1930
1900 ON ERROR GOTO 1970 ' Bei Fehler (Datei nicht vorhanden)
1910 KILL N$+".KAR"
1920 GOTO 1490
1930 REM Warnhinweis wenn kein Dateiname angegeben wurde
1940 PRINT "Kein Name angegeben. Es wird keine Kartei gelscht."
1950 PRINT
1960 GOTO 1490
1970 REM Fehlermeldung wenn die Kartei nicht vorhanden ist
1980 PRINT "Kein Karteikasten unter dem Namen ";N$;" vorhanden."
1990 PRINT
2000 RESUME 1490
2010 REM Erzeugen eines neuen, leeren Karteikastens
2020 REM Eingabe eines Namens fr den neuen Karteikasten
2030 PRINT "Der neue Karteikasten mu einen Namen bekommen, ";
2040 PRINT "damit er hinterher durch Angabe"
2050 PRINT "dieses Namens benutzt werden kann. Ein Name ";
2060 PRINT "besteht aus bis zu acht Buchstaben"
2070 PRINT "oder Ziffern."
2080 PRINT
2090 PRINT "Welchen Namen soll der neue Karteikasten tragen ? ";
2100 GOSUB 5460
2110 PRINT
2120 IF N$<>"" THEN GOTO 2170
2130 REM Warnhinweis wenn kein Dateiname eingegeben wurde
2140 PRINT "Kein Name angegeben. Es wird kein Karteikasten bearbeitet."
2150 PRINT
2160 GOTO 1490
2170 REM Abtesten, ob Name fr den Karteikasten wirklich neu ist
2180 ON ERROR GOTO 2250
2190 OPEN N$+".KAR" FOR INPUT AS #1
2200 CLOSE #1
2210 PRINT "Ein Karteikasten mit dem Namen ";N$;" existiert schon."
2220 PRINT
2230 GOTO 1490
2240 REM Der Name fr den neuen Karteikasten ist wirklich neu
2250 RESUME 2260
2260 ON ERROR GOTO 0
2270 REM Eingabe der Feldbezeichnungen der neuen Karteikarten
2280 PRINT "Jedes Feld mu einen Namen tragen, damit ";
2290 PRINT "der Rechner hinterher die Eingaben den"
2300 PRINT "entsprechenden Feldern zuordnen kann. Sinnvolle ";
2310 PRINT "Namen sind z.B. Name, Strae,"
2320 PRINT "Ort bei Adrekarteien. Wenn die Namen fr ";
2330 PRINT "alle Felder eingegeben worden sind,"
2340 PRINT "drckt man zum Abschlu nur auf die ";
2350 PRINT "Wagenrcklauftaste [Enter] ohne einen"
2360 PRINT "Namen eingegeben zu haben."
2370 PRINT
2380 PRINT "Der Name des  1. Feldes der Karteikarte ? ";
2390 LINE INPUT S$(1)
2400 IF S$(1)="" THEN GOTO 2580
2410 LET F% = 1
2420   PRINT "Bezeichnung von Feld ";F%+1;" der Karteikarte ? ";
2430   LINE INPUT S$(F%+1)
2440   IF S$(F%+1)="" THEN GOTO 2470
2450     LET F% = F%+1
2460     GOTO 2420
2470 PRINT
2480 REM Erzeugen einer Datei fr den neuen Karteikasten
2490 ON ERROR GOTO 2630
2500 OPEN N$+".KAR" FOR OUTPUT AS #1
2510 FOR I% = 1 TO F%
2520   PRINT #1,S$(I%)
2530 NEXT I%
2540 PRINT #1,""
2550 PRINT #1,""
2560 CLOSE #1
2570 GOTO 1490
2580 REM Warnhinweis wenn kein Feldname angegeben wurde
2590 PRINT
2600 PRINT "Kein Feldname angegeben. Es wird kein neuer Karteikasten erzeugt."
2610 PRINT
2620 GOTO 1490
2630 REM Fehlermeldung wenn die Diskette voll ist
2640 PRINT "Die Diskette ist voll. Kann Karteikasten ";N$;" nicht erzeugen."
2650 PRINT
2660 RESUME 1490
2670 REM Bearbeiten eines vorhandenen Karteikastens
2680 REM Eingabe des Namens des zu benutzenden Karteikastens
2690 PRINT "Name des zu benutzenden Karteikastens ? ";
2700 GOSUB 5460
2710 PRINT
2720 IF N$<>"" THEN GOTO 2770
2730 REM Warnhinweis wenn kein Dateiname eingegeben wurde
2740 PRINT "Kein Name angegeben. Es wird kein Karteikasten aufgesucht."
2750 PRINT
2760 GOTO 1490
2770 REM Lesen der Feldbezeichnungen der Karteikarten
2780 ON ERROR GOTO 1970
2790 OPEN N$+".KAR" FOR INPUT AS #1
2800 ON ERROR GOTO 3000
2810 LINE INPUT #1,S$(1)
2820 IF S$(1)="" THEN GOTO 3020
2830 LET F% = 1
2840 LET L% = LEN(S$(1))
2850   LINE INPUT #1,S$(F%+1)
2860   IF S$(F%+1)="" THEN GOTO 2900
2870     LET F% = F%+1
2880     IF L%<LEN(S$(F%)) THEN LET L% = LEN(S$(F%))
2890     GOTO 2850
2900 REM Lesen der Informationen auf den einzelnen Karteikarten
2910 LET A% = 0
2920   LINE INPUT #1,S$((A%+1)*F%+1)
2930   IF S$((A%+1)*F%+1)="" THEN GOTO 3060
2940   LET A% = A%+1
2950   LET I% = 2
2960     IF I%>F% THEN GOTO 2920
2970     LINE INPUT #1,S$(A%*F%+I%)
2980     LET I% = I%+1
2990   GOTO 2960
3000 REM Fehlermeldung wenn der Karteikasten durcheinander ist
3010 RESUME 3020
3020 REM Fehlermeldung wenn der Karteikasten durcheinander ist
3030 PRINT "Die Informationen in ";N$;" sind nicht im richtigen Format."
3040 PRINT
3050 GOTO 1490
3060 REM Karteikasten erfolgreich gelesen
3070 CLOSE #1
3080 ON ERROR GOTO 0
3090 PRINT "Der Karteikasten ";N$;" enthlt";A%;"Karteikarte";
3100 IF A%<>1 THEN PRINT "n";
3110 PRINT
3120 PRINT
3130 REM Anzeigen des Hauptmens
3140 PRINT "Auswahl :"
3150 PRINT
3160 PRINT "1) Hinzufgen neuer Karteikarten"
3170 PRINT "2) ndern den Inhalts vorhandener Karteikarten"
3180 PRINT "3) Anzeigen des Inhalts vorhandener Karteikarten"
3190 PRINT "4) Lschen vorhandener Karteikarten"
3200 PRINT "5) Ausdrucken vorhandener Karteikarten"
3210 PRINT "0) Zurck"
3220 PRINT
3230 PRINT "Bitte Kennziffer eingeben -> ";
3240 REM Eingabe der Kennziffer entgegennehmen
3250   LET Z$ = INKEY$
3260   IF Z$="" THEN GOTO 3250
3270   IF Z$>="0" AND Z$<="5" THEN GOTO 3310
3280   IF Z$=CHR$(3) THEN END ' Abbruch durch ^C ermglichen
3290   PRINT CHR$(7);
3300   GOTO 3250
3310 PRINT Z$
3320 PRINT
3330 REM Je nach Auswahl zum geeigneten Programmstck verzweigen
3340 IF Z$="1" THEN GOTO 3400
3350 IF Z$="2" THEN GOTO 3660
3360 IF Z$="3" THEN GOTO 3920
3370 IF Z$="4" THEN GOTO 4590
3380 IF Z$="5" THEN GOTO 4850
3390 GOTO 5020
3400 REM Hinzufgen neuer Karteikarten zum bisherigen Bestand
3410 PRINT "Die Angaben, die die neue Karteikarte tragen ";
3420 PRINT "soll, eingeben. Der Rechner fragt"
3430 PRINT "bei jedem Feld, was dort eingetragen werden ";
3440 PRINT "soll. Neue Karteikarten werden"
3450 PRINT "solange hinzugefgt, bis der Benutzer bei ";
3460 PRINT "dem ersten Feld einer Karteikarte"
3470 PRINT "ohne eine Eingabe zu machen nur auf die ";
3480 PRINT "Wagenrcklauftaste drckt."
3490   PRINT
3500   PRINT "Inhalt der Karteikarte";A%+1;"eingeben. Ein ";
3510   PRINT "leeres Feld beendet die Eingabe."
3520   PRINT
3530   PRINT S$(1);TAB(L%+1);" ? ";
3540   LINE INPUT S$((A%+1)*F%+1)
3550   IF S$((A%+1)*F%+1)="" THEN GOTO 3630
3560   LET A% = A%+1
3570   IF I%<2 THEN GOTO 3620
3580   FOR I% = 2 TO F%
3590     PRINT S$(I%);TAB(L%+1);" ? ";
3600     LINE INPUT S$(A%*F%+I%)
3610   NEXT I%
3620 GOTO 3490
3630 REM Durch Leereingabe Eingabesequenz abgebrochen
3640 PRINT
3650 GOTO 3090
3660 REM ndern vorhandener Karteikarten
3670 IF A%=0 THEN GOTO 5420
3680 GOSUB 5220
3690 FOR K% = 1 TO A%
3700   LET I% = 1
3710   IF S$((A%+1)*F%+I%)="" THEN GOTO 3730
3720   IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 3900
3730   LET I% = I%+1
3740   IF I%<=F% THEN GOTO 3710
3750   PRINT "ndern der Karteikarte";K%
3760   PRINT
3770   FOR I% = 1 TO F%
3780     PRINT S$(I%);TAB(L%+1);" : ";S$(K%*F%+I%)
3790   NEXT I%
3800   PRINT
3810   PRINT "Die zu verndernden Informationen eintragen, ";
3820   PRINT "andere leer lassen."
3830   PRINT
3840   FOR I% = 1 TO F%
3850     PRINT S$(I%);TAB(L%+1);" ? ";
3860     LINE INPUT X$
3870     IF X$<>"" THEN LET S$(K%*F%+I%) = X$
3880   NEXT I%
3890   PRINT
3900 NEXT K%
3910 GOTO 3140
3920 REM Anzeigen vorhandener Karteikarten auf dem Bildschirm
3930 IF A%=0 THEN GOTO 5420
3940 GOSUB 5220
3950 LET M% = 0 ' noch keine passende Karteikarte gefunden
3960 FOR K% = 1 TO A% ' alle Karteikarte abklappern
3970   LET I% = 1 ' beginnend beim ersten Feld der Karteikarte
3980     IF S$((A%+1)*F%+I%)="" THEN GOTO 4000
3990     IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 4030
4000     LET I% = I%+1
4010   IF I%<=F% THEN GOTO 3980
4020   LET M% = M%+1 ' eine weitere passende Karteikarte gefunden
4030 NEXT K%
4040 PRINT M%;"passende Karteikarten vorhanden."
4050 PRINT
4060 IF M%=0 THEN GOTO 3140 ' keine Karteikarte, keine Anzeige
4070 LET K% = 0 ' derzeitig bei Karteikarte 0
4080 LET T% = 0 ' das ist die 0. passende
4090 LET U% = 1 ' suche 1. passende auf
4100   IF T%=U% THEN GOTO 4280 ' passende gefunden, anzeigen
4110     IF T%>U% THEN GOTO 4200 ' gehe nach vorne
4120       LET K% = K%+1 ' gehe nach hinten
4130       LET I% = 1 ' beginnend beim 1. Feld der Karteikarte
4140         IF S$((A%+1)*F%+I%)="" THEN GOTO 4160
4150         IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 4120
4160         LET I% = I%+1
4170       IF I%<=F% THEN GOTO 4140
4180       LET T% = T%+1
4190     GOTO 4100
4200       LET K% = K%-1 ' gehe nach vorne
4210       LET I% = 1 ' beginnend beim ersten Feld der Karteikarte
4220         IF S$((A%+1)*F%+I%)="" THEN GOTO 4240
4230         IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 4200
4240         LET I% = I%+1
4250       IF I%<=F% THEN GOTO 4220
4260       LET T% = T%-1
4270     GOTO 4100
4280   PRINT "Karteikarte Nr.";K%;":"
4290   PRINT
4300   FOR I% = 1 TO F%
4310     PRINT S$(I%);TAB(L%+1);" : ";S$(K%*F%+I%)
4320   NEXT I%
4330   PRINT
4340   PRINT "Welche Karteikarte soll jetzt angezeigt werden ?"
4350   PRINT 
4360   IF T%>1 THEN PRINT "1) die erste passende"
4370   IF T%>1 THEN PRINT "2) die vorige passende"
4380   IF T%<M% THEN PRINT "3) die nchste passende"
4390   IF T%<M% THEN PRINT "4) die letzte passende"
4400   PRINT "0) zurck zum Men"
4410   PRINT
4420   PRINT "Bitte Kennziffer eingeben -> ";
4430     LET Z$ = INKEY$
4440     IF Z$="" THEN GOTO 4430
4450     IF Z$=CHR$(3) THEN END ' Programmabbruch durch ^C
4460     IF Z$="0" THEN GOTO 4510
4470     IF T%>1 AND Z$>="1" AND Z$<="2" THEN GOTO 4510
4480     IF T%<M% AND Z$>="3" AND Z$<="4" THEN GOTO 4510
4490     PRINT CHR$(7);
4500     GOTO 4430
4510   PRINT Z$
4520   PRINT
4530   IF Z$="0" THEN GOTO 3140
4540   IF Z$="1" THEN LET U% = 1
4550   IF Z$="2" AND U%>1 THEN LET U% = U%-1
4560   IF Z$="3" AND U%<M% THEN LET U% = U%+1
4570   IF Z$="4" THEN LET U% = M%
4580   GOTO 4100
4590 REM Lschen vorhandener Karteikarten
4600 IF A%=0 THEN GOTO 5420
4610 GOSUB 5220
4620 LET K% = 1
4630   LET I% = 1
4640     IF S$((A%+1)*F%+I%)="" THEN GOTO 4660
4650     IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 4820
4660     LET I% = I%+1
4670   IF I%<=F% THEN GOTO 4640
4680   FOR I% = 1 TO F%
4690     PRINT S$(I%);TAB(L%+1);" : ";S$(K%*F%+I%)
4700   NEXT I%
4710   PRINT
4720   PRINT "Diese Karteikarte lschen (J/N) ? ";
4730     LET Z$ = INKEY$
4740   IF Z$<>"J" AND Z$<>"N" AND Z$<>"j" AND Z$<>"n" THEN GOTO 4730
4750   PRINT Z$
4760   IF Z$="n" OR Z$="N" THEN GOTO 4810
4770     FOR I% = K%*F%+1 TO A%*F%+F%
4780       LET S$(I%) = S$(I%+F%)
4790     NEXT I%
4800     LET A% = A%-1
4810   PRINT
4820   LET K% = K%+1
4830 IF K%<=A% THEN GOTO 4630
4840 GOTO 3090
4850 REM Ausdrucken vorhandener Karteikarten
4860 IF A%=0 THEN GOTO 5420
4870 GOSUB 5220
4880 PRINT "Die Ausgabe erscheint auf dem Drucker ..."
4890 FOR K% = 1 TO A%
4900   LET I% = 1
4910     IF S$((A%+1)*F%+I%)="" THEN GOTO 4930
4920     IF INSTR(S$(K%*F%+I%),S$((A%+1)*F%+I%))=0 THEN GOTO 4990
4930     LET I% = I%+1
4940   IF I%<=F% THEN GOTO 4910
4950   FOR I% = 1 TO F%
4960     LPRINT S$(I%);TAB(L%+1);" : ";S$(K%*F%+I%)
4970   NEXT I%
4980   LPRINT
4990 NEXT K%
5000 PRINT
5010 GOTO 3140
5020 REM Zurck zum Eingangsmen
5030 REM Abspeichern des Karteikastens unter dem Namen N$
5040 ON ERROR GOTO 5180
5050 OPEN N$+".KAR" FOR OUTPUT AS #1
5060 FOR I% = 1 TO F%
5070   PRINT #1,S$(I%)
5080 NEXT I%
5090 PRINT #1,""
5100 FOR I% = F%+1 TO A%*F%+F%
5110   PRINT #1,S$(I%)
5120 NEXT I%
5130 PRINT #1,""
5140 CLOSE #1
5150 PRINT "Kartei ";N$;" erfolgreich abgespeichert."
5160 PRINT
5170 GOTO 1490
5180 REM Fehlermeldung, die erscheint, wenn die Diskette voll ist
5190 PRINT "Kann die Kartei nicht abspeichern (Diskette fehlt?)."
5200 PRINT
5210 RESUME 3080
5220 REM Eingeben der Maske zur Auswahl der selektierten Karteikarten
5230 PRINT "Mit der folgenden Maske kann betimmt werden, ";
5240 PRINT "welche Karteikarten von der ausge-"
5250 PRINT "whlten Operation betroffen sind. Wird bei ";
5260 PRINT "jedem Feld nur auf die Wagenrck-"
5270 PRINT "lauftaste [Enter] gedrckt, dann werden ";
5280 PRINT "alle Karteikarten ausgewhlt, gibt man"
5290 PRINT "bei einem Feld etwas ein, dann nur die ";
5300 PRINT "Karteikarten, die in diesem Feld diese"
5310 PRINT "Aufschrift enthalten. Gibt man alle Informationen ";
5320 PRINT "ein, dann wird nur diese";
5330 PRINT "eine Karteikarte ausgewhlt (falls sie ";
5340 PRINT "vorhanden ist)."
5350 PRINT
5360 FOR I% = 1 TO F%
5370   PRINT S$(I%);TAB(L%+1);" ? ";
5380   LINE INPUT S$((A%+1)*F%+I%)
5390 NEXT I%
5400 PRINT
5410 RETURN
5420 REM Warnmeldung wenn keine passenden Karteikarten vorhanden sind
5430 PRINT "Keine Karteikarten vorhanden."
5440 PRINT
5450 GOTO 3140
5460 REM Eingabe eines Dateinamens mit Umwandlung in Grossbuchstaben
5470 LINE INPUT N$
5480 FOR J% = 1 TO LEN(N$)
5490   IF MID$(N$,J%,1)<"a" OR MID$(N$,J%,1)>"z" THEN GOTO 5510
5500     LET N$ = LEFT$(N$,J%-1)+CHR$(ASC(MID$(N$,J%,1))-32)+MID$(N$,J%+1)
5510 NEXT J%
5520 RETURN
