1000 PRINT "Darstellung von Funktionsgraphen in BASIC"
1010 PRINT
1020 PRINT "IBM-PC BASICA Version vom 1.12.88 von M. Winterhoff"
1030 PRINT
1040 REM Dieses Programm erwartet zunchst die Eingabe von Rechenformeln, die
1050 REM dann auf syntaktische Korrektheit hin berprft werden (im Fehlerfalle
1060 REM wird die fehlerhafte Position markiert und die Eingabe wiederholt) und
1070 REM gleichzeitig in den Code fr einen Formelinterpreter bersetzt werden.
1080 REM Danach wird die Eingabe von linker, rechter, oberer und unterer Grenze
1090 REM des Ausschnitts verlangt, der von den Funktionen dargestellt werden
1100 REM soll, auf den Graphikbildschirm umgeschaltet, eine Titelzeile, die Y-
1110 REM Achsen-Werte und die X-Achsen-Werte hingeschrieben, ein Achsenkreuz
1120 REM mit Markierungen gezeichnet und nacheinander fr jede Funktion Punkt
1130 REM fr Punkt der Wert an der entsprechenden Stelle ausgerechnet und eine
1140 REM Linie zwischen den Punkten gezeichnet. Hat die Funktion einen freien
1150 REM Parameter, so nimmt der Parameter nacheinander die vorgegebenen Werte
1160 REM an und das Zeichnen wird wiederholt. Danach erscheint ein Hinweis
1170 REM und es wird vor dem Zurckschalten auf den Textbildschirm auf einen
1180 REM Tastendruck gewartet. Der Benutzer kann angeben, ob und wie das
1190 REM Programm fortgesetzt oder beendet wird.
1200 REM
1210 REM Bedeutung der im Compiler | Interpreter verwendeten Variablen :
1220 REM
1230 REM A% = Anzahl der bisher in den Formeln auftauchenden Konstanten
1240 REM B%(J%-1) = Beginn (erster Befehl) des Programms fr die Funktion J%
1250 REM B%(J%)-1 = Ende des Programms fr die Funktion J%
1260 REM C$ = das derzeitig behandelte Zeichen von F$, also MID$(F$,I%,1)
1270 REM      oder das eingegebene Zeichen bei der Kommandoabfrage
1280 REM D%(T%) = mathematische Funktion auf Klammerebene T% oder 0
1290 REM DX = reale Distanz zwischen zwei Bildpunkten
1300 REM E% = 1, wenn Fehler beim Ausrechnen der Funktion an der Stelle X
1310 REM F$ = enthlt die eingetippten Funktionsgleichungen, kommagetrennt
1320 REM H% = Hhe eines Zeichens in Bildpunktzeilen
1330 REM HF = Hhenfaktor zur Umrechnung von Y in Y%
1340 REM I% = derzeitige Position bei der Untersuchung der Formel in F$
1350 REM J% = Nummer der gerade gezeichneten Funktion, Zahlenanfangsposition
1360 REM K(1)..K(A%) = die Werte der bisher verwendeten Konstanten
1370 REM L = Wert der linken Grenze des Bildausschnitts
1380 REM N% = Nummer der gerade bersetzten Funktion, danach Anzahl der F'n
1390 REM O = Wert der oberen Grenze des Bildausschnitts
1400 REM P%() = das Programm fr den Formelinterpreter
1410 REM Q = temporrer Wert, bei der Vertauschung der Grenzen verwendet
1420 REM R = Wert der rechten Grenze des Bildausschnitts
1430 REM S(1)..S(T%) = Stapelspeicher fr Zwischenresultate
1440 REM T% = oberster Kellerspeicherplatz (Klammerebene)
1450 REM U = Wert der unteren Grenze des Bildausschnitts
1460 REM VA(1)..VA(N%) = Anfangswert der freien Variablen fr Funktion 1..N%
1470 REM VB(1)..VB(N%) = zweiter Wert der freien Variablen fr Funktion 1..N%
1480 REM VE(1)..VE(N%) = Endwert der freien Variablen fr Funktion 1..N%
1490 REM V$(1)..V$(N%) = in Funktion 1..N% verwendeter Name fr freie Variable
1500 REM W% = Breite eines Zeichens in Bildpunkten
1510 REM X = Wert der Stelle, an der der Funktionwert ausgerechnet werden soll
1520 REM X1% = Bildpunktspalte des derzeitigen Werts der Funktions-Stelle
1530 REM X2% = vorhergehende Bildpunktspalte
1540 REM Y = ausgerechneter Wert der Funktion an der Stelle X
1550 REM Y1% = Bildpunktzeile des derzeitigen Werts der Funktion
1560 REM Y2% = vorhergehende Bildpunktzeile
1570 REM YO% = oberste von Funktion verwendete Bildpunktzeile
1580 REM YU% = unterste von Funktion verwendete Bildpunktzeile
1590 REM Z% = Nummer des Speicherplatzes des gerade bearbeiteten Befehls
1600 REM
1610 DIM B%(10),P%(100),K(100),S(100),D%(100),VA(10),VB(10),VE(10),V$(10)
1620 KEY OFF
1630 PRINT "Dieses Programm zeichnet einen Ausschnitt des Graphen der Funktion,"
1640 PRINT "deren Rechenformel vom Benutzer des Programms, neben den Grenzen"
1650 PRINT "des Bildausschnitts, eingegeben wird. Bei der Eingabe der Rechen-"
1660 PRINT "formel sind die Operatoren +,-,*,/,^ und die Funkionen ABS,ATN,COS,"
1670 PRINT "EXP,FIX,INT,LOG,SGN,SIN,SQR und TAN zulssig. Die Variable X gibt"
1680 PRINT "die X-Position an. Beispiel fr eine Formel: SIN(X)/X ."
1690 PRINT "Es knnen mehrere, durch Kommata getrennte Formeln eingegeben"
1700 PRINT "werden, die dann bereinander gezeichnet werden."
1710 PRINT "Jede Funktion kann einen freien Parameter besitzen, der durch einen"
1720 PRINT "Buchstaben angegeben wird. Das Programm fragt vor der Erstellung"
1730 PRINT "der Zeichnung nach den Werten, die die freien Parameter annehmen"
1740 PRINT "sollen."
1750 PRINT
1760 PRINT "Formel ? ";
1770 LINE INPUT F$
1780 IF F$="" THEN 5010
1790 REM In der Eingabezeile F$ alle Kleinbuchstaben in Grobuchstaben umwandeln
1800 FOR I% = 1 TO LEN(F$)
1810   LET C$ = MID$(F$,I%,1)
1820   IF C$<"a" OR C$>"z" THEN GOTO 1840
1830     LET F$ = LEFT$(F$,I%-1)+CHR$(ASC(C$)-ASC("a")+ASC("A"))+MID$(F$,I%+1)
1840 NEXT I%
1850 REM Alles vorbereiten, um die erste Formel zu analysieren und zu bersetzen
1860 LET I% = 0
1870 LET N% = 1
1880 LET A% = 0
1890 LET T% = 1
1900 LET Z% = 1
1910 LET B%(0) = 1
1920 LET V$(N%) = ""
1930 GOSUB 4260 ' nchstes Zeichen
1940 GOSUB 3350 ' Term
1950 LET B%(N%) = Z%
1960 IF C$="" THEN GOTO 2020
1970 LET N% = N%+1
1980 IF C$="," THEN GOTO 1920
1990 REM Fehler in Rechenformel F$ bei Position I% entdeckt. Melde und markiere
2000 PRINT "Fehler :";SPACE$(I%);"^"
2010 GOTO 1760
2020 REM Formeln waren korrekt, Eingabe der freien Parameter falls vorhanden
2030 PRINT
2040 FOR I% = 1 TO N%
2050   IF V$(I%)="" THEN GOTO 2160
2060     PRINT "Anfangswert  fr freie Variable ";V$(I%);" ";
2070     INPUT VA(I%)
2080     PRINT "Zweiter Wert fr freie Variable ";V$(I%);" ";
2090     INPUT VB(I%)
2100     IF VA(I%)<>VB(I%) THEN GOTO 2130
2110       PRINT "Anfangswert und zweiter Wert mssen verschieden sein."
2120       GOTO 2080
2130     PRINT "Endwert      fr freie Variable ";V$(I%);" ";
2140     INPUT VE(I%)
2150     PRINT
2160 NEXT I%
2170 REM Eingabe der Grenzen
2180 PRINT
2190 PRINT "linke  Grenze (kleinster X-Wert) ";
2200 INPUT L
2210 PRINT
2220 PRINT "rechte Grenze (grter   X-Wert) ";
2230 INPUT R
2240 PRINT
2250 IF ABS(L-R)>1E-30 THEN GOTO 2290
2260 PRINT "Nun, der Abstand ist ein bichen zu klein. Wiederhole die Eingabe."
2270 PRINT
2280 GOTO 2190
2290 IF L<R THEN GOTO 2330
2300 PRINT "Linke Grenze war grer als rechte Grenze. Ich vertausche beide."
2310 PRINT
2320 LET Q = L : LET L = R : LET R = Q
2330 PRINT "untere Grenze (kleinster Y-Wert) ";
2340 INPUT U
2350 PRINT
2360 PRINT "obere  Grenze (grter   Y-Wert) ";
2370 INPUT O
2380 PRINT
2390 IF ABS(U-O)>1E-30 THEN GOTO 2430
2400 PRINT "Nun, der Abstand ist ein bichen zu klein. Wiederhole die Eingabe."
2410 PRINT
2420 GOTO 2330
2430 IF U<O THEN GOTO 2470
2440 PRINT "Untere Grenze war grer als obere Grenze. Ich vertausche beide."
2450 PRINT
2460 LET Q = U : LET U = O : LET O = Q
2470 REM Umschalten auf Graphikbildschirm
2480 DEF SEG = 64
2490 IF PEEK(73)>6 THEN GOTO 2530
2500   LET H% = 8
2510   LET W% = 8
2520 GOTO 2550
2530   LET H% = 14
2540   LET W% = 9
2550 SCREEN 2
2560 REM berschrift anbringen
2570 IF LEN(F$)>68 THEN LET F$ = "Formel zu lang, um sie hier darzustellen"
2580 PRINT "         Y";SPACE$(34-(LEN(F$)/2));F$
2590 REM Y-Achsen Skalierung anbringen
2600 FOR Y = O TO U+(U-O)/20 STEP (U-O)/10
2610 PRINT USING "##.##^^^^";Y
2620 PRINT
2630 NEXT Y
2640 REM X-Achsen Skalierung anbringen
2650 LET X = (R-L)/5
2660 PRINT "    ";
2670 PRINT USING "   ##.##^^^^";L,L+X,L+2*X,L+3*X,L+4*X,R;
2680 LOCATE 23,79
2690 PRINT "X"
2700 REM Achsenkreuz und Wertemarkierungen zeichnen
2710 LINE (10.5*W%,H%)-(10.5*W%,22*H%) : LINE (10.5*W%+1,H%)-(10.5*W%+1,22*H%)
2720 LINE (10.5*W%+2,22*H%)-(76*W%,22*H%)
2730 FOR Y1% = 1.5*H% TO 22*H% STEP 2*H%
2740   LINE (10*W%,Y1%)-(10.5*W%-1,Y1%)
2750 NEXT Y1%
2760 FOR X1% = 11.5*W% TO 72*W% STEP 12*W%
2770   LINE (X1%,22*H%+1)-(X1%,22.5*H%) : LINE (X1%+1,22*H%+1)-(X1%+1,22.5*H%)
2780 NEXT X1%
2790 REM Graphen zeichnen
2800 LET DX = (R-L)/(60*W%)
2810 LET HF = -20*H%/(O-U)
2820 LET YO% = 1.5*H%
2830 LET YU% = 21.5*H%
2840 REM Nullinie einzeichnen, wenn vorhanden
2850 IF U>0 OR O<0 THEN GOTO 2900
2860   LET Y1% = -U*HF+YU% ' Position der Nullinie auf dem Bildschirm
2870   FOR X1% = 11*W% TO 75*W% STEP W%
2880     LINE (X1%,Y1%)-(X1%+W%/2,Y1%)
2890   NEXT X1%
2900 FOR J% = 1 TO N%
2910   LET V = VA(J%) ' freie Variable Anfangswert
2920   LET X2% = 11.5*W%
2930   LET Y2% = YO% ' Y2% bekommt beliebigen Wert innerhalb des Ausschnitts
2940   LET X = L ' X beginnt bei der linken Grenze des Ausschnitts
2950   GOSUB 4320 ' Wert Y der Formel F$ an der Stelle X ausrechnen
2960   IF E%=0 THEN LET Y2% = (Y-U)*HF+YU% ' Y in Y2% umrechnen
2970     LET X = X + DX ' X geht einen Bildpunkt weiter nach rechts
2980     GOSUB 4320 ' Wert Y der Formel F$ an der Stelle X ausrechnen
2990     LET X1% = X2%
3000     LET X2% = X2%+1
3010     IF E% THEN GOTO 3060
3020       LET Y1% = Y2%
3030       LET Y2% = (Y-U)*HF+YU% ' Y in Y2% umrechnen
3040       LINE (X1%,Y1%)-(X2%,Y2%) : LINE (X2%,Y1%)-(X2%+1,Y2%)
3050     GOTO 3070
3060       LINE (X1%,YO%)-(X1%,YU%) : LINE (X2%,YO%)-(X2%,YU%)
3070   IF X<R+DX/2 THEN GOTO 2970 ' noch nicht rechter Rand ...
3080   IF V$(J%)="" THEN GOTO 3160
3090     IF VB(J%)<VA(J%) THEN GOTO 3130
3100       LET V = V+VB(J%)-VA(J%)
3110       IF V>VE(J%)+(VB(J%)-VA(J%))/2 THEN GOTO 3160
3120     GOTO 2920
3130       LET V = V-VB(J%)+VA(J%)
3140       IF V<VE(J%)+(VB(J%)-VA(J%))/2 THEN GOTO 3160
3150       GOTO 2920
3160 NEXT J%
3170 REM Hinweis und Warten auf Tastendruck
3180 LOCATE 25,1
3190 PRINT "Zum Weitermachen auf eine beliebige Taste druecken ...";
3200 IF INKEY$="" THEN GOTO 3200
3210 SCREEN 0 : WIDTH 80 ' Zurckschalten auf Textbildschirm
3220 PRINT "Wie soll es weitergehen ?"
3230 PRINT
3240 PRINT "1) Derselbe Funktionsgraph nocheinmal"
3250 PRINT "2) Dieselbe Funktion in anderen Grenzen"
3260 PRINT "3) Dieselbe Funktion mit anderem Parameter in anderen Grenzen"
3270 PRINT "4) Eine andere Funktion
3280 PRINT "0) Zurck zu BASIC"
3290 PRINT
3300 PRINT "Geben Sie eine Kennziffer ein -> ";
3310   LET C$ = INKEY$
3320   IF C$<"0" OR C$>"4" THEN GOTO 3310
3330 PRINT C$
3340 ON ASC(C$)-ASC("0")+1 GOTO 5010,2550,2170,2020,1750
3350 REM *** Term
3360 IF C$<>"-" THEN GOTO 3410
3370   GOSUB 4260 ' nchstes Zeichen
3380   GOSUB 3530 ' Faktor
3390   LET P%(Z%) = 2 : LET Z% = Z%+1 ' Negationsbefehl
3400   GOTO 3430
3410 IF C$="+" THEN GOSUB 4260 ' nchstes Zeichen
3420 GOSUB 3530 ' Faktor
3430 IF C$<>"+" THEN GOTO 3480
3440   GOSUB 4260 ' nchstes Zeichen
3450   GOSUB 3530 ' Faktor
3460   LET P%(Z%) = 3 : LET Z% = Z%+1 ' Additionsbefehl
3470   GOTO 3430
3480 IF C$<>"-" THEN RETURN
3490   GOSUB 4260 ' nchstes Zeichen
3500   GOSUB 3530 ' Faktor
3510   LET P%(Z%) = 4 : LET Z% = Z%+1 ' Subtraktionsbefehl
3520   GOTO 3430
3530 REM *** Faktor
3540 GOSUB 3650 ' Potenz
3550 IF C$<>"*" THEN GOTO 3600
3560   GOSUB 4260 ' nchstes Zeichen
3570   GOSUB 3650 ' Potenz
3580   LET P%(Z%) = 5 : LET Z% = Z%+1 ' Multiplikationsbefehl
3590   GOTO 3550
3600 IF C$<>"/" THEN RETURN
3610   GOSUB 4260 ' nchstes Zeichen
3620   GOSUB 3650 ' Potenz
3630   LET P%(Z%) = 6 : LET Z% = Z%+1 ' Divisionsbefehl
3640   GOTO 3550
3650 REM *** Potenz
3660 GOSUB 3720 ' Wert
3670 IF C$<>"^" THEN RETURN
3680 GOSUB 4260 ' nchstes Zeichen
3690 GOSUB 3650 ' Potenz
3700 LET P%(Z%) = 19 : LET Z% = Z%+1 ' Potenzierungsbefehl
3710 GOTO 3670
3720 REM *** Wert dem vielleicht eine Funktion vorangeht
3730 IF LEN(MID$(F$,I%,3))<3 THEN GOTO 3800
3740 LET D%(T%) = INSTR("ABSATNCOSEXPFIXINTLOGSGNSINSQRTAN",MID$(F$,I%,3))
3750 IF D%(T%) MOD 3<>1 THEN GOTO 3800
3760 LET D%(T%) = D%(T%)\3+8
3770 LET I% = I%+3 ' Wort und
3780 GOSUB 4280 ' nachfolgende Leerzeichen berspringen
3790 GOTO 3810
3800 LET D%(T%) = 0
3810 REM Wert ohne Funktion
3820 IF C$<>"X" THEN GOTO 3860
3830 LET P%(Z%) = 1 : LET Z% = Z%+1 ' X-Wert Ladebefehl
3840 GOSUB 4260 ' nchstes Zeichen
3850 GOTO 4230
3860 REM *** Test auf freie Variable
3870 IF C$<"A" OR C$>"Z" THEN GOTO 3930
3880 IF V$(N%)<>"" AND V$(N%)<>C$ THEN GOTO 1990 ' Fehler
3890 LET V$(N%) = C$
3900 LET P%(Z%) = 20 : LET Z% = Z%+1 ' freie Variable
3910 GOSUB 4260 ' nchstes Zeichen
3920 GOTO 4230
3930 REM *** geklammerter Ausdruck
3940 IF C$<>"(" THEN GOTO 4020 ' Zahl
3950 GOSUB 4260 ' nchstes Zeichen
3960 LET T% = T%+1 ' eine Klammerebene tiefer gehen
3970 GOSUB 3360 ' Term
3980 LET T% = T%-1 ' aus einer Klammerebene herauskommen
3990 IF C$<>")" THEN GOTO 1990 ' Fehler
4000 GOSUB 4260 ' nchstes Zeichen
4010 GOTO 4230
4020 REM *** Zahl
4030 IF INSTR("0123456789",C$)=0 THEN GOTO 1990 ' Fehler
4040 LET J% = I% ' Anfang der Zahl merken
4050 LET I% = I%+1
4060 LET C$ = MID$(F$,I%,1)
4070 IF INSTR("0123456789",C$)<>0 AND C$<>"" THEN GOTO 4050 
4080 IF C$<>"." THEN GOTO 4120
4090 LET I% = I%+1
4100 LET C$ = MID$(F$,I%,1)
4110 IF INSTR("0123456789",C$)<>0 AND C$<>"" THEN GOTO 4090
4120 IF C$<>"E" THEN GOTO 4190
4130 LET I% = I%+1
4140 LET C$ = MID$(F$,I%,1)
4150 IF C$<>"+" AND C$<>"-" THEN GOTO 4180
4160 LET I% = I%+1
4170 LET C$ = MID$(F$,I%,1)
4180 IF INSTR("0123456789",C$)<>0 AND C$<>"" THEN GOTO 4160
4190 LET A% = A%+1
4200 LET K(A%) = VAL(MID$(F$,J%,I%-J%+1))
4210 LET P%(Z%) = 20+A% : LET Z% = Z%+1 ' Konstantenladebefehl
4220 GOSUB 4290 ' Leerzeichen berspringen
4230 IF D%(T%)=0 THEN GOTO 4250
4240   LET P%(Z%) = D%(T%) : LET Z% = Z%+1 ' Funktionsbefehl
4250 RETURN
4260 REM nchstes Zeichen
4270 LET I% = I%+1
4280 LET C$ = MID$(F$,I%,1)
4290 REM Leerzeichen berspringen
4300 IF C$=" " THEN GOTO 4260 
4310 RETURN
4320 REM Interpreter
4330 REM Die vom Interpreter bearbeiteten Maschinencodes in P%():
4340 REM  1: PUSH X     2: NEGATE     3: ADD        4: SUB        5: MUL
4350 REM  6: DIV        7: ABS        8: ATN        9: COS       10: EXP
4360 REM 11: EXP       12: FIX       13: INT       14: LOG       15: SGN
4370 REM 16: SIN       17: SQR       18: TAN       19: POWER     20: PUSH V
4380 REM 21: PUSH K(1) 22: PUSH K(2) 23: PUSH K(3) 24: PUSH K(4) 25: PUSH K(5)
4390 REM 26: PUSH K(6) 27: PUSH K(7) 28: PUSH K(8) 29: PUSH K(9) 30: PUSH K(10)
4400 LET E% = 0 ' kein Fehler durch berlauf bisher
4410 LET T% = 0 ' kein Wert auf dem Kellerspeicher
4420 ON ERROR GOTO 4940
4430 FOR Z% = B%(J%-1) TO B%(J%)-1
4440   ON P%(Z%)    GOTO 4490,4550,4570,4600,4630,4660,4280,4690,4710,4730
4450   ON P%(Z%)-10 GOTO 4750,4770,4790,4810,4830,4850,4870,4890,4910,4520
4460   LET T% = T%+1
4470   LET S(T%) = K(P%(Z%)-20)
4480   GOTO 4960
4490   LET T% = T%+1
4500   LET S(T%) = X
4510   GOTO 4960
4520   LET T% = T%+1
4530   LET S(T%) = V
4540   GOTO 4960
4550   LET S(T%) = -S(T%)
4560   GOTO 4960
4570   LET T% = T%-1
4580   LET S(T%) = S(T%)+S(T%+1)
4590   GOTO 4960
4600   LET T% = T%-1
4610   LET S(T%) = S(T%)-S(T%+1)
4620   GOTO 4960
4630   LET T% = T%-1
4640   LET S(T%) = S(T%)*S(T%+1)
4650   GOTO 4960
4660   LET T% = T%-1
4670   LET S(T%) = S(T%)/S(T%+1)
4680   GOTO 4960
4690   LET S(T%) = ABS(S(T%))
4700   GOTO 4960
4710   LET S(T%) = ATN(S(T%))
4720   GOTO 4960
4730   LET S(T%) = COS(S(T%))
4740   GOTO 4960
4750   LET S(T%) = EXP(S(T%))
4760   GOTO 4960
4770   LET S(T%) = FIX(S(T%))
4780   GOTO 4960
4790   LET S(T%) = INT(S(T%))
4800   GOTO 4960
4810   LET S(T%) = LOG(S(T%))
4820   GOTO 4960
4830   LET S(T%) = SGN(S(T%))
4840   GOTO 4960
4850   LET S(T%) = SIN(S(T%))
4860   GOTO 4960
4870   LET S(T%) = SQR(S(T%))
4880   GOTO 4960
4890   LET S(T%) = TAN(S(T%))
4900   GOTO 4960
4910   LET T% = T%-1
4920   LET S(T%) = S(T%)^S(T%+1)
4930   GOTO 4960
4940   LET E% = 1 ' Rechenfehler
4950   RESUME 4960
4960 NEXT Z%
4970 ON ERROR GOTO 0
4980 LET Y = S(1)
4990 IF Y<U THEN LET Y=U ELSE IF Y>O THEN LET Y=O
5000 RETURN
5010 REM Programmende
5020 KEY ON
5030 END
